/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
)

// checks if the ConversationMessageData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ConversationMessageData{}

// ConversationMessageData struct for ConversationMessageData
type ConversationMessageData struct {
	Media []ConversationMessageDataMediaInner `json:"media,omitempty"`
	Error *ConversationMessageDataError `json:"error,omitempty"`
	Contacts []MessageContact `json:"contacts,omitempty"`
	Location *Location `json:"location,omitempty"`
	Template *ConversationMessageDataTemplate `json:"template,omitempty"`
	Header *MessageHeader `json:"header,omitempty"`
	Footer *MessageFooter `json:"footer,omitempty"`
	Buttons []MessageButton `json:"buttons,omitempty"`
	List *List `json:"list,omitempty"`
	MessengerTag *MessengerTag `json:"messenger_tag,omitempty"`
	OrderDetails *MessageOrderDetails `json:"order_details,omitempty"`
	OrderStatus *MessageOrderStatus `json:"order_status,omitempty"`
	Context *SendMessageContext `json:"context,omitempty"`
	Reaction *MessageReaction `json:"reaction,omitempty"`
	Cards []MessageCard `json:"cards,omitempty"`
}

// NewConversationMessageData instantiates a new ConversationMessageData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConversationMessageData() *ConversationMessageData {
	this := ConversationMessageData{}
	return &this
}

// NewConversationMessageDataWithDefaults instantiates a new ConversationMessageData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConversationMessageDataWithDefaults() *ConversationMessageData {
	this := ConversationMessageData{}
	return &this
}

// GetMedia returns the Media field value if set, zero value otherwise.
func (o *ConversationMessageData) GetMedia() []ConversationMessageDataMediaInner {
	if o == nil || IsNil(o.Media) {
		var ret []ConversationMessageDataMediaInner
		return ret
	}
	return o.Media
}

// GetMediaOk returns a tuple with the Media field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetMediaOk() ([]ConversationMessageDataMediaInner, bool) {
	if o == nil || IsNil(o.Media) {
		return nil, false
	}
	return o.Media, true
}

// HasMedia returns a boolean if a field has been set.
func (o *ConversationMessageData) HasMedia() bool {
	if o != nil && !IsNil(o.Media) {
		return true
	}

	return false
}

// SetMedia gets a reference to the given []ConversationMessageDataMediaInner and assigns it to the Media field.
func (o *ConversationMessageData) SetMedia(v []ConversationMessageDataMediaInner) {
	o.Media = v
}

// GetError returns the Error field value if set, zero value otherwise.
func (o *ConversationMessageData) GetError() ConversationMessageDataError {
	if o == nil || IsNil(o.Error) {
		var ret ConversationMessageDataError
		return ret
	}
	return *o.Error
}

// GetErrorOk returns a tuple with the Error field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetErrorOk() (*ConversationMessageDataError, bool) {
	if o == nil || IsNil(o.Error) {
		return nil, false
	}
	return o.Error, true
}

// HasError returns a boolean if a field has been set.
func (o *ConversationMessageData) HasError() bool {
	if o != nil && !IsNil(o.Error) {
		return true
	}

	return false
}

// SetError gets a reference to the given ConversationMessageDataError and assigns it to the Error field.
func (o *ConversationMessageData) SetError(v ConversationMessageDataError) {
	o.Error = &v
}

// GetContacts returns the Contacts field value if set, zero value otherwise.
func (o *ConversationMessageData) GetContacts() []MessageContact {
	if o == nil || IsNil(o.Contacts) {
		var ret []MessageContact
		return ret
	}
	return o.Contacts
}

// GetContactsOk returns a tuple with the Contacts field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetContactsOk() ([]MessageContact, bool) {
	if o == nil || IsNil(o.Contacts) {
		return nil, false
	}
	return o.Contacts, true
}

// HasContacts returns a boolean if a field has been set.
func (o *ConversationMessageData) HasContacts() bool {
	if o != nil && !IsNil(o.Contacts) {
		return true
	}

	return false
}

// SetContacts gets a reference to the given []MessageContact and assigns it to the Contacts field.
func (o *ConversationMessageData) SetContacts(v []MessageContact) {
	o.Contacts = v
}

// GetLocation returns the Location field value if set, zero value otherwise.
func (o *ConversationMessageData) GetLocation() Location {
	if o == nil || IsNil(o.Location) {
		var ret Location
		return ret
	}
	return *o.Location
}

// GetLocationOk returns a tuple with the Location field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetLocationOk() (*Location, bool) {
	if o == nil || IsNil(o.Location) {
		return nil, false
	}
	return o.Location, true
}

// HasLocation returns a boolean if a field has been set.
func (o *ConversationMessageData) HasLocation() bool {
	if o != nil && !IsNil(o.Location) {
		return true
	}

	return false
}

// SetLocation gets a reference to the given Location and assigns it to the Location field.
func (o *ConversationMessageData) SetLocation(v Location) {
	o.Location = &v
}

// GetTemplate returns the Template field value if set, zero value otherwise.
func (o *ConversationMessageData) GetTemplate() ConversationMessageDataTemplate {
	if o == nil || IsNil(o.Template) {
		var ret ConversationMessageDataTemplate
		return ret
	}
	return *o.Template
}

// GetTemplateOk returns a tuple with the Template field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetTemplateOk() (*ConversationMessageDataTemplate, bool) {
	if o == nil || IsNil(o.Template) {
		return nil, false
	}
	return o.Template, true
}

// HasTemplate returns a boolean if a field has been set.
func (o *ConversationMessageData) HasTemplate() bool {
	if o != nil && !IsNil(o.Template) {
		return true
	}

	return false
}

// SetTemplate gets a reference to the given ConversationMessageDataTemplate and assigns it to the Template field.
func (o *ConversationMessageData) SetTemplate(v ConversationMessageDataTemplate) {
	o.Template = &v
}

// GetHeader returns the Header field value if set, zero value otherwise.
func (o *ConversationMessageData) GetHeader() MessageHeader {
	if o == nil || IsNil(o.Header) {
		var ret MessageHeader
		return ret
	}
	return *o.Header
}

// GetHeaderOk returns a tuple with the Header field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetHeaderOk() (*MessageHeader, bool) {
	if o == nil || IsNil(o.Header) {
		return nil, false
	}
	return o.Header, true
}

// HasHeader returns a boolean if a field has been set.
func (o *ConversationMessageData) HasHeader() bool {
	if o != nil && !IsNil(o.Header) {
		return true
	}

	return false
}

// SetHeader gets a reference to the given MessageHeader and assigns it to the Header field.
func (o *ConversationMessageData) SetHeader(v MessageHeader) {
	o.Header = &v
}

// GetFooter returns the Footer field value if set, zero value otherwise.
func (o *ConversationMessageData) GetFooter() MessageFooter {
	if o == nil || IsNil(o.Footer) {
		var ret MessageFooter
		return ret
	}
	return *o.Footer
}

// GetFooterOk returns a tuple with the Footer field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetFooterOk() (*MessageFooter, bool) {
	if o == nil || IsNil(o.Footer) {
		return nil, false
	}
	return o.Footer, true
}

// HasFooter returns a boolean if a field has been set.
func (o *ConversationMessageData) HasFooter() bool {
	if o != nil && !IsNil(o.Footer) {
		return true
	}

	return false
}

// SetFooter gets a reference to the given MessageFooter and assigns it to the Footer field.
func (o *ConversationMessageData) SetFooter(v MessageFooter) {
	o.Footer = &v
}

// GetButtons returns the Buttons field value if set, zero value otherwise.
func (o *ConversationMessageData) GetButtons() []MessageButton {
	if o == nil || IsNil(o.Buttons) {
		var ret []MessageButton
		return ret
	}
	return o.Buttons
}

// GetButtonsOk returns a tuple with the Buttons field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetButtonsOk() ([]MessageButton, bool) {
	if o == nil || IsNil(o.Buttons) {
		return nil, false
	}
	return o.Buttons, true
}

// HasButtons returns a boolean if a field has been set.
func (o *ConversationMessageData) HasButtons() bool {
	if o != nil && !IsNil(o.Buttons) {
		return true
	}

	return false
}

// SetButtons gets a reference to the given []MessageButton and assigns it to the Buttons field.
func (o *ConversationMessageData) SetButtons(v []MessageButton) {
	o.Buttons = v
}

// GetList returns the List field value if set, zero value otherwise.
func (o *ConversationMessageData) GetList() List {
	if o == nil || IsNil(o.List) {
		var ret List
		return ret
	}
	return *o.List
}

// GetListOk returns a tuple with the List field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetListOk() (*List, bool) {
	if o == nil || IsNil(o.List) {
		return nil, false
	}
	return o.List, true
}

// HasList returns a boolean if a field has been set.
func (o *ConversationMessageData) HasList() bool {
	if o != nil && !IsNil(o.List) {
		return true
	}

	return false
}

// SetList gets a reference to the given List and assigns it to the List field.
func (o *ConversationMessageData) SetList(v List) {
	o.List = &v
}

// GetMessengerTag returns the MessengerTag field value if set, zero value otherwise.
func (o *ConversationMessageData) GetMessengerTag() MessengerTag {
	if o == nil || IsNil(o.MessengerTag) {
		var ret MessengerTag
		return ret
	}
	return *o.MessengerTag
}

// GetMessengerTagOk returns a tuple with the MessengerTag field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetMessengerTagOk() (*MessengerTag, bool) {
	if o == nil || IsNil(o.MessengerTag) {
		return nil, false
	}
	return o.MessengerTag, true
}

// HasMessengerTag returns a boolean if a field has been set.
func (o *ConversationMessageData) HasMessengerTag() bool {
	if o != nil && !IsNil(o.MessengerTag) {
		return true
	}

	return false
}

// SetMessengerTag gets a reference to the given MessengerTag and assigns it to the MessengerTag field.
func (o *ConversationMessageData) SetMessengerTag(v MessengerTag) {
	o.MessengerTag = &v
}

// GetOrderDetails returns the OrderDetails field value if set, zero value otherwise.
func (o *ConversationMessageData) GetOrderDetails() MessageOrderDetails {
	if o == nil || IsNil(o.OrderDetails) {
		var ret MessageOrderDetails
		return ret
	}
	return *o.OrderDetails
}

// GetOrderDetailsOk returns a tuple with the OrderDetails field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetOrderDetailsOk() (*MessageOrderDetails, bool) {
	if o == nil || IsNil(o.OrderDetails) {
		return nil, false
	}
	return o.OrderDetails, true
}

// HasOrderDetails returns a boolean if a field has been set.
func (o *ConversationMessageData) HasOrderDetails() bool {
	if o != nil && !IsNil(o.OrderDetails) {
		return true
	}

	return false
}

// SetOrderDetails gets a reference to the given MessageOrderDetails and assigns it to the OrderDetails field.
func (o *ConversationMessageData) SetOrderDetails(v MessageOrderDetails) {
	o.OrderDetails = &v
}

// GetOrderStatus returns the OrderStatus field value if set, zero value otherwise.
func (o *ConversationMessageData) GetOrderStatus() MessageOrderStatus {
	if o == nil || IsNil(o.OrderStatus) {
		var ret MessageOrderStatus
		return ret
	}
	return *o.OrderStatus
}

// GetOrderStatusOk returns a tuple with the OrderStatus field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetOrderStatusOk() (*MessageOrderStatus, bool) {
	if o == nil || IsNil(o.OrderStatus) {
		return nil, false
	}
	return o.OrderStatus, true
}

// HasOrderStatus returns a boolean if a field has been set.
func (o *ConversationMessageData) HasOrderStatus() bool {
	if o != nil && !IsNil(o.OrderStatus) {
		return true
	}

	return false
}

// SetOrderStatus gets a reference to the given MessageOrderStatus and assigns it to the OrderStatus field.
func (o *ConversationMessageData) SetOrderStatus(v MessageOrderStatus) {
	o.OrderStatus = &v
}

// GetContext returns the Context field value if set, zero value otherwise.
func (o *ConversationMessageData) GetContext() SendMessageContext {
	if o == nil || IsNil(o.Context) {
		var ret SendMessageContext
		return ret
	}
	return *o.Context
}

// GetContextOk returns a tuple with the Context field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetContextOk() (*SendMessageContext, bool) {
	if o == nil || IsNil(o.Context) {
		return nil, false
	}
	return o.Context, true
}

// HasContext returns a boolean if a field has been set.
func (o *ConversationMessageData) HasContext() bool {
	if o != nil && !IsNil(o.Context) {
		return true
	}

	return false
}

// SetContext gets a reference to the given SendMessageContext and assigns it to the Context field.
func (o *ConversationMessageData) SetContext(v SendMessageContext) {
	o.Context = &v
}

// GetReaction returns the Reaction field value if set, zero value otherwise.
func (o *ConversationMessageData) GetReaction() MessageReaction {
	if o == nil || IsNil(o.Reaction) {
		var ret MessageReaction
		return ret
	}
	return *o.Reaction
}

// GetReactionOk returns a tuple with the Reaction field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetReactionOk() (*MessageReaction, bool) {
	if o == nil || IsNil(o.Reaction) {
		return nil, false
	}
	return o.Reaction, true
}

// HasReaction returns a boolean if a field has been set.
func (o *ConversationMessageData) HasReaction() bool {
	if o != nil && !IsNil(o.Reaction) {
		return true
	}

	return false
}

// SetReaction gets a reference to the given MessageReaction and assigns it to the Reaction field.
func (o *ConversationMessageData) SetReaction(v MessageReaction) {
	o.Reaction = &v
}

// GetCards returns the Cards field value if set, zero value otherwise.
func (o *ConversationMessageData) GetCards() []MessageCard {
	if o == nil || IsNil(o.Cards) {
		var ret []MessageCard
		return ret
	}
	return o.Cards
}

// GetCardsOk returns a tuple with the Cards field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessageData) GetCardsOk() ([]MessageCard, bool) {
	if o == nil || IsNil(o.Cards) {
		return nil, false
	}
	return o.Cards, true
}

// HasCards returns a boolean if a field has been set.
func (o *ConversationMessageData) HasCards() bool {
	if o != nil && !IsNil(o.Cards) {
		return true
	}

	return false
}

// SetCards gets a reference to the given []MessageCard and assigns it to the Cards field.
func (o *ConversationMessageData) SetCards(v []MessageCard) {
	o.Cards = v
}

func (o ConversationMessageData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ConversationMessageData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Media) {
		toSerialize["media"] = o.Media
	}
	if !IsNil(o.Error) {
		toSerialize["error"] = o.Error
	}
	if !IsNil(o.Contacts) {
		toSerialize["contacts"] = o.Contacts
	}
	if !IsNil(o.Location) {
		toSerialize["location"] = o.Location
	}
	if !IsNil(o.Template) {
		toSerialize["template"] = o.Template
	}
	if !IsNil(o.Header) {
		toSerialize["header"] = o.Header
	}
	if !IsNil(o.Footer) {
		toSerialize["footer"] = o.Footer
	}
	if !IsNil(o.Buttons) {
		toSerialize["buttons"] = o.Buttons
	}
	if !IsNil(o.List) {
		toSerialize["list"] = o.List
	}
	if !IsNil(o.MessengerTag) {
		toSerialize["messenger_tag"] = o.MessengerTag
	}
	if !IsNil(o.OrderDetails) {
		toSerialize["order_details"] = o.OrderDetails
	}
	if !IsNil(o.OrderStatus) {
		toSerialize["order_status"] = o.OrderStatus
	}
	if !IsNil(o.Context) {
		toSerialize["context"] = o.Context
	}
	if !IsNil(o.Reaction) {
		toSerialize["reaction"] = o.Reaction
	}
	if !IsNil(o.Cards) {
		toSerialize["cards"] = o.Cards
	}
	return toSerialize, nil
}

type NullableConversationMessageData struct {
	value *ConversationMessageData
	isSet bool
}

func (v NullableConversationMessageData) Get() *ConversationMessageData {
	return v.value
}

func (v *NullableConversationMessageData) Set(val *ConversationMessageData) {
	v.value = val
	v.isSet = true
}

func (v NullableConversationMessageData) IsSet() bool {
	return v.isSet
}

func (v *NullableConversationMessageData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConversationMessageData(val *ConversationMessageData) *NullableConversationMessageData {
	return &NullableConversationMessageData{value: val, isSet: true}
}

func (v NullableConversationMessageData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConversationMessageData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


